package RPM::Source::Transformation::Factory;

use strict;
use warnings;

use RPM::Source::Transformation::Component;
use RPM::Source::Transformation::OptHandlerWrapper;

our $VERSION=0.006;
our @ISA=qw(RPM::Source::Transformation::Component);

use Exporter 'import';
our @EXPORT = qw(TRANSFORMATION_FAILURE TRANSFORMATION_OK
PRIORITY_PRE_BUNDLE
PRIORITY_BUNDLE
PRIORITY_BUNDLE_COLLECT
PRIORITY_BUNDLE_SETUP
PRIORITY_BUNDLE_RESET
PRIORITY_BUNDLE_FILL
PRIORITY_POST_BUNDLE
PRIORITY_AT_BEGIN
PRIORITY_POST_BEGIN
PRIORITY_SRPM_AT_BEGIN
PRIORITY_SRPM_POST_BEGIN
PRIORITY_PREHOOKS
PRIORITY_PRECONVERT
PRIORITY_CONVERT
PRIORITY_FILTER_PREDISTROMAP
PRIORITY_FILTER_DISTROMAP
PRIORITY_FILTER_POSTDISTROMAP
PRIORITY_POSTCONVERT
PRIORITY_HOOKS
PRIORITY_POSTHOOKS
PRIORITY_COMMANDLINE
PRIORITY_DEFAULT
PRIORITY_POSTPROCESS
PRIORITY_PRERELEASE
PRIORITY_AT_END
);

use constant {
	TRANSFORMATION_FAILURE	=> RPM::Source::TransformContainer::TRANSFORMATION_FAILURE,
	TRANSFORMATION_OK	=> RPM::Source::TransformContainer::TRANSFORMATION_OK,

	# bundle import...
	PRIORITY_PRE_BUNDLE	=> 190, # before main
	PRIORITY_BUNDLE		=> 180, # main, like PerlBuilder.pm main
	PRIORITY_BUNDLE_COLLECT	=> 170, # after main, still collecting metadata
	PRIORITY_BUNDLE_SETUP	=> 160, # apply metadata to spec
	PRIORITY_BUNDLE_RESET	=> 150, # reset; sync our macros with spec
	PRIORITY_BUNDLE_FILL	=> 140, # fill %prep,%build,%install,%files...
	PRIORITY_POST_BUNDLE	=> 130,
	# srpmtool...
	PRIORITY_SRPM_AT_BEGIN	=> 120,
	PRIORITY_SRPM_POST_BEGIN=> 110,
	# will be removed/moved
	PRIORITY_AT_BEGIN	=> 120,
	PRIORITY_POST_BEGIN	=> 110,
	PRIORITY_PREHOOKS	=> 100,
	PRIORITY_PRECONVERT	=>  90,
	PRIORITY_CONVERT	=>  80,
	PRIORITY_FILTER_PREDISTROMAP	=>  70,
	PRIORITY_FILTER_DISTROMAP	=>  60,
	PRIORITY_FILTER_POSTDISTROMAP	=>  50,
	PRIORITY_POSTCONVERT	=>  40,
	PRIORITY_HOOKS		=>  30,
	PRIORITY_POSTHOOKS	=>  20,
	PRIORITY_COMMANDLINE	=>  10,
	PRIORITY_DEFAULT	=>  0,
	PRIORITY_POSTPROCESS	=> -10,
	PRIORITY_PRERELEASE	=> -20,
	PRIORITY_AT_END		=> -30,
};

sub init_factory {}
sub transformations {
    return;
}

1;
