package RPM::Source::Transformation::Factory::Buildreq;

use strict;
use warnings;
use Carp;

use RPM::Source::Transformation::Factory;
use RPM::Source::Transformation::Resource::Buildreq;

our @ISA=qw/RPM::Source::Transformation::Factory/;

push @RPM::Source::TransformContainer::FACTORY_CLASSES, __PACKAGE__;

our $VERSION=0.002;
# $verbose=0;
our $opt_buildreq_merge_sourcedep_entry;

sub register_messages {
    my ($self,$extopt)=@_;
    ### TODO: use some fixed keys hash here
    RPM::Source::Transformation::Component::add_opt($extopt, {
	-opt_buildreq_merge_sourcedep_entry => $opt_buildreq_merge_sourcedep_entry,
    });
}

sub transformations {
    return RPM::Source::Transformation::OptHandlerWrapper->new(
	-priority => PRIORITY_PRERELEASE,
	-name => 'add_buildreq',
	-opt_handler_sub=>\&opt_handler);
}

sub opt_handler {
    my (undef,$spec,$parent,$opt,$resourceobj)=@_;
    my $buildreq=$resourceobj->{'__buildreq'};
    if ($buildreq) {
	$buildreq->update_spec_entry($spec, -merge_sourcedep_entry => $opt->{-opt_buildreq_merge_sourcedep_entry});
    }
    return RPM::Source::TransformContainer::TRANSFORMATION_OK;
}

1;
